﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading.Tasks;

namespace WinFormsApp2;


[ComImport(), Guid("886d8eeb-8cf2-4446-8d02-cdba1dbdcf99"), InterfaceType(ComInterfaceType.InterfaceIsIUnknown)]
internal interface IPropertyStore
{
    [PreserveSig]
    HRESULT GetCount([Out] out int cProps);
    HRESULT GetAt([In] int iProp, [Out] out PROPERTYKEY pkey);
    HRESULT GetValue([In] ref PROPERTYKEY key, [Out] out PROPVARIANT pv);
    HRESULT SetValue([In] ref PROPERTYKEY key, [In] ref PROPERTYKEY propvar);
    HRESULT Commit();
}
