﻿using System;

namespace WinFormsApp2;

public struct UI11
{
    ushort value;

    public UI11()
    {
        value = 0;
    }

    public UI11(int value)
    {
        if (value < 0) throw new Exception("Underflow, value must be grater than -1");
        if (value > 2047) throw new Exception("Overflow, value must be smaller than 2028, because it is a 11 Bit value");
        this.value = (ushort)value;
    }

    public UI11(uint value)
    {
        if (value > 2047) throw new Exception("Overflow, value must be smaller than 2028, because it is a 11 Bit value");
        this.value = (ushort)value;
    }
    public UI11(long value)
    {
        if (value < 0) throw new Exception("Underflow, value must be grater than -1");
        if (value > 2047) throw new Exception("Overflow, value must be smaller than 2028, because it is a 11 Bit value");
        this.value = (ushort)value;
    }

    public UI11(ulong value)
    {
        if (value > 2047) throw new Exception("Overflow, value must be smaller than 2028, because it is a 11 Bit value");
        this.value = (ushort)value;
    }

    public static implicit operator UI11(byte value) { return new UI11(value); }
    public static implicit operator UI11(short value) { return new UI11(value); }
    public static implicit operator UI11(ushort value) { return new UI11(value); }
    public static implicit operator UI11(int value) { return new UI11(value); }
    public static implicit operator UI11(uint value) { return new UI11(value); }
    public static implicit operator UI11(long value) { return new UI11(value); }
    public static implicit operator UI11(ulong value) { return new UI11(value); }

    public static implicit operator byte(UI11 value)
    {
        if (value > byte.MaxValue)
        {
            throw new OverflowException();
        }
        return (byte)value;
    }

    public static implicit operator short(UI11 value)
    {
        if (value.value > short.MaxValue)
        {
            throw new OverflowException();
        }
        return (short)value.value;
    }

    public static implicit operator ushort(UI11 value) => value.value;
    public static implicit operator int(UI11 value) => value.value;
    public static implicit operator uint(UI11 value) => value.value;
    public static implicit operator long(UI11 value) => value.value;
    public static implicit operator ulong(UI11 value) => value.value;


}
